/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.h 2114 2011-06-22 02:07:06Z ertl-honda $
 */

/*
 *		ץå¸⥸塼SH34ѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *  åΥ֥°
 */
#define TARGET_INHATR	TA_NONKERNEL	/* ͥγ */
#define TARGET_INTATR	(TA_NEGEDGE|TA_POSEDGE) /* °ΥåȰ¸Ѥӥå */

/*
 *  顼åˡλ
 */
#define CHECK_STKSZ_ALIGN	4	/* åΥ饤ñ */
#define CHECK_FUNC_ALIGN	4	/* ؿΥ饤ñ */
#define CHECK_FUNC_NONNULL		/* ؿNULLå */
#define CHECK_STACK_ALIGN	4	/* åΰΥ饤ñ */
#define CHECK_STACK_NONNULL		/* åΰNULLå */
#define CHECK_MPF_ALIGN		4	/* ĹסΰΥ饤ñ */
#define CHECK_MPF_NONNULL		/* ĹסΰNULLå */
#define CHECK_MB_ALIGN		4	/* ΰΥ饤ñ */
/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char_t *)(istk) + (istksz)))

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} TSKCTXB;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ͥ٥ޥ饤֥
 *  
 *  SH34Ǥϡơ쥸SRˤ47ӥåȤ4ӥåȤ˳ͥ
 *  ޥʥϡɥγͥ٥ޥIPMˤ֤Ƥ롥IPM
 *  ¸Ƥˡͥ٤γɽ-1Ϣ³͡ˤȤ
 *  ȤǽǤ뤬;פʺӥåȥեȤȿžɬפˤʤ롥
 *  򤱤뤿ˡIPM¸ˤϡSR47ӥåȤФ
 *  ȤȤˤ롥ͤͥ٥ޥɽȸƤӡIIPMȽ
 *  Ȥˤ롥
 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡCAST
 */
#define EXT_IPM(iipm)    (-CAST(PRI,(iipm) >> 4))       /* ɽɽ */
#define INT_IPM(ipm)     (CAST(uint16_t, -(ipm)) << 4)  /* ɽɽ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint8_t
current_iipm(void)
{
    return((uint8_t)(current_sr() & 0xF0U));
}

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint8_t iipm)
{
    set_sr((current_sr() & ~0xF0U) | iipm);
}

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  SH34ϥơ쥸(SR)˳ͥ٥ޥ(IPM)äƤ롥
 *  CPUåե饰ǽʤΤᡤŪCPUå
 *  饰¸롥
 *
 *  ޤCPUå֤ѿ(lock_flag)Ѱդ롥
 *
 *  CPUåե饰ꥢƤ֤ϡIPMǥγͥ
 *  ޥͤꤹ롥δ֤ϡǥγͥ٥ޥϡ
 *  IPMѤ롥
 * 
 *  ФCPUåե饰åȤ줤֤ϡIPM򡤥ͥ
 *  ΤΤ٤Ƥγ׵ޥ(TIPM_LOCK)ȡ
 *  γͥ٥ޥȤι⤤ꤹ롥δ֤Υǥγ
 *  ͥ٥ޥϡΤѿ(saved_iipm, ɽݻ)
 *  դݻ롥
 */

/*
 *  ƥȤλ
 *
 *  SH34ǤϡƥȤȽˡߤΥͥȲ
 *  R7_BANK1Ѥ롥
 * 
 */
Inline bool_t
sense_context(void)
{
    uint32_t nest;

    Asm("stc r7_bank,%0" : "=r"(nest));
    return(nest > 0U);
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUå֤Ǥγͥ٥ޥ
 *
 *  TIPM_LOCKϡCPUå֤Ǥγͥ٥ޥʤ
 *  ΤΤ٤Ƥγߤޥͤ롥
 */
#define TIPM_LOCK    TMIN_INTPRI

/*
 *  CPUå֤Ǥγͥ٥ޥɽ
 */
#define IIPM_LOCK    INT_IPM(TIPM_LOCK)

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL  INT_IPM(TIPM_ENAALL)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUåե饰¸Τѿ
 * 
 *  ѿϡCPUå֤λΤ߽񤭴Ƥ褤Ȥ롥
 *  饤ؿǡνѲʤ褦volatile ꡥ 
 */
extern volatile bool_t    lock_flag;   /* CPUåե饰ͤݻѿ */
extern volatile uint8_t saved_iipm;  /* ͥ٤ޥѿ */

/*
 *  CPUå֤ؤΰܹ
 *
 *  IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *  ͥΤΤ٤Ƥγߤޥ͡TIPM_LOCKˤ
 *  ꤹ롥ޤlock_flagtrueˤ롥
 *
 *  IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *  saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϡǥ
 *  γͥ٥ޥTIPM_LOCKƱ⤤٥
 *  Ƥ֤ˤ롥
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *  ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
    uint8_t iipm;

    /*
     *  current_iipm()֤ͤľsaved_iipm¸ѿiipm
     *  ѤƤΤϡcurrent_iipm()Ƥľ˳ߤȯ
     *  ư줿߽saved_iipmѹǽ뤿
     *  롥
     */
    iipm = current_iipm();
    if (IIPM_LOCK > iipm) {
        set_iipm(IIPM_LOCK);
    }
    saved_iipm = iipm;
    lock_flag = true;
    /* ƥ륻ǥ꤬񤭴ǽ */
    Asm("":::"memory");
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β
 *
 *  lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *  saved_iipm¸᤹ͤ
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *  ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
    /* ƥ륻ǥ꤬񤭴ǽ */
    Asm("":::"memory");
    lock_flag = false;
    set_iipm(saved_iipm);
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
    return(lock_flag);
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

/*
 *  chg_ipmͭʳͥ٤ϰϤȽ
 *
 *  TMIN_INTPRIͤˤ餺chg_ipmǤϡ-15TIPM_ENAALLʡ0ˤϰ
 *  Ǥ뤳ȤȤʥåγĥˡ
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-15 <= (intpri) && (intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *  CPUåե饰ꥢƤϡϡɥγͥ٥
 *  ꤹ롥CPUåե饰åȤƤϡsaved_iipm
 *  ꤷˡϡɥγͥ٥ޥꤷ褦
 *  ʥǥΡ˳ͥ٥ޥTIPM_LOCKι⤤ꤹ롥
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint8_t   iipm = INT_IPM(intpri);

    if (!lock_flag) {
        set_iipm(iipm);
    }
    else {
        saved_iipm = iipm;
#if TIPM_LOCK == -15
        /*
         *  TIPM_LOCK-15ξˤϡλǥϡɥγͥ
         *  ٥ޥɬ15ꤵƤ뤿ᡤꤷʤɬפʤ
         */
#else /* TIPM_LOCK == -15 */
        set_iipm(iipm > IIPM_LOCK ? iipm : IIPM_LOCK);
#endif /* TIPM_LOCK == -15 */
    }
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *  CPUåե饰ꥢƤϥϡɥγͥ٥
 *  򡤥åȤƤsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
    uint8_t iipm;

    if (!lock_flag) {
        iipm = current_iipm();
    }
    else {
        iipm = saved_iipm;
    }
    return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФprc_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void    start_r(void);

#define activate_context(p_tcb)                                         \
{                                                                       \
    (p_tcb)->tskctxb.sp = (void *)((char_t *)((p_tcb)->p_tinib->stk)    \
                                        + (p_tcb)->p_tinib->stksz);     \
    (p_tcb)->tskctxb.pc = (void *) start_r;                             \
}

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 */
Inline void
initialize_exception(void)
{
}
     
/*
 *  SH34γߥƥȳ߽ǥμ¸
 * 
 *  SH34γߤϡե⥸塼ߡIRQ, PINTߤʬ
 *  Ǥ줾찷ۤʤ롥Τᡤߥϥɥֹ椫顤
 *  γߤʬह뤿ΥޥѰդ롥
 * 
 *  PINTߤ15bitΥץåؤγ׵饤Ǽ¸Ƥ뤬
 *  IRCؤγ׵饤PINT0PINT7PINT0PINT7Ȥä2ܤˤʤ
 *  Ƥ롥ΤᡤͥǤ̤ˤϰ鷺2ܤγߤȤư
 *  PINTϡ̤PINTER쥸ˤĶػ߲ǽǤ뤬ͥ
 *  ϡPINTER쥸ϼ갷ʤΤᡤPINTER쥸
 *  ϡ桼ץǹԤɬפ롥ƱͤPINT׵٥
 *  ꤹICR2桼ץǹԤɬפ롥ʤ
 *  ߤꤷݤγߥϥɥǤIRR0Υꥢ
 *  i_begin_int()ǹԤPINTߤɤȽꤹޥѰդ롥
 *
 *  ƱͤIRQߤȽꤹޥѰդ롥
 */

/*
 *  PINTߤɤȽꤹ뤿Υޥ
 */
#define INTNO_PINT(intno) ((0x700 == (intno)) || (0x720 == (intno)))
#define INTNO_PINT_OFFSET(intno) (((intno) - 0x700) >> 5)

/*
 *  IRQߤɤȽꤹ뤿Υޥ
 */
#define INTNO_IRQ(intno) ((TMIN_IRQNO <= (intno)) && ((intno) <= TMAX_IRQNO))
#define INTNO_IRQ_OFFSET(intno) (((intno) - TMIN_IRQNO) >> 5)
     
/*
 *  ͥ
 *
 *  Ƴߤγͥ٤ϳͥ쥸(IPRXX)ˤä
 *  ꤹ롥ե⥸塼ξ硤ե⥸塼ǽǤ롥
 *  㤨SCIFϡERI2, RXI2, BRI2, TXI2Ȥ4Ĥγ׵饤
 *  ݡȤ뤬Ƥγ׵饤ФƱͥ٤
 *  ʤΤᡤƳ׵饤ˤɤγͥ쥸
 *  ꤹ뤫ơ֥Ѱդ롥ޤֹϢ³
 *  ƤᡤݡȤƤʤֹˤϡnumber-1ꤹ롥ơ
 *  ֥
 */

/*
 *  ƳֹꤹIPRξΤι¤  
 */
typedef struct {
    /* IPRA:0, IPRB:1, IPRC:2, IPRD:3, IPRE:4, IPRF:5, IPRG:6 */
    uint32_t address; 
    /* bit512:3, bit118:2, bit74:1, bit30:0 */
    uint8_t  offset;
} IPR_INFO;

/*
 *  ƳֹIPRξơ֥
 */
extern const IPR_INFO ipr_info_tbl[TNUM_INH];
    
/*
 *  ֹ桦ߥϥɥֹ
 *
 *  ߥϥɥֹ(inhno)ȳֹ(intno)ϡȯ˳
 *  ߻ݥ쥸ꤵͤѤ롥߻ݥ쥸ϡINTEVT
 *  INTEVT22बꡤ줾ꤵͤۤʤ롥SH34
 *  INTEVTѤƤߤINTEVT2Ѥ롥Τᡤץ
 *  åηեѰդơɤΥ쥸Ѥ뤬
 *  ꤹ뤳ȤȤ롥ޤݡȤߤκۤʤ뤿ᡤ
 *  ͤץåηե롥
 *
 *  INTENTꤵͤϥѡͤǤ뤿ᡤΤޤޤͤͥ
 *  Υơ֥ΥǥåѤȡ̵̤ΰ褬ȯ롥
 *  ΤᡤͥǤϡINTENTꤵͤ򥷥եȤͤѤ
 *  롥եȤͤץå˰ۤʤ뤿ץåη
 *  ե롥
 *
 *  ɽ̾ϡiintno,iinhnoȤ롥
 */

/*
 *  ֹϰϤȽ
 * 
 *  TMIN_INTNOTMAX_INTNOϰϤǤäƤֹͭǤʤ礬뤿
 *  ᡤipr_info_tbl[]ֹͭ椫å
 */
#define VALID_INTNO(intno) \
        ((TMIN_INTNO <= (intno)) && ((intno) <= TMAX_INTNO) && (ipr_info_tbl[INT_INTNO(intno)].address != 0U))
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)

/*
 *  CPU㳰ϥɥֹ
 *
 *  CPU㳰ϥɥֹȤƤϡ㳰ݥ쥸ꤹ㳰ɤ
 *  Ѥ롥ݡȤCPU㳰ϥɥϥץåη˰ۤʤ
 *  ǡץåηե롥
 *
 *  ߥϥɥֹƱCPU㳰ϥɥֹ⥹ѡǤ뤿ᡤ
 *  ͥǤͤ򥷥եȤɽѤ롥 
 */
#define VALID_EXCNO_DEFEXC(excno) \
        (TMIN_EXCNO <= (excno) && (excno) <= TMAX_EXCNO)

/*
 *  ߥϥɥ
 *
 *  ߥϥɥϿ롥ߥϥɥơ֥Τϥե
 *  졼Ū
 */ 
extern const FP inh_tbl[TNUM_INH];

/*
 *  ߥϥɥ
 *
 *  ٥ȥֹinhnoγߥϥɥεưint_entryꤹ롥
 *  ϥɥơ֥
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 *  ׵ػߥե饰
 *
 *  SH34IRCϳ׵ػߥե饰ʤߤػߤϡ
 *  ͥ쥸(IPRXX)0ꤹɬפ롥ͥ
 *  쥸0ˤ뤳Ȥǳ׵ػߥե饰¸Ȥ
 *  ֡ͥ٤򵭲Ƥΰ褬ɬפȤʤ롥ե졼
 *  ǤΥơ֥Ѱդ롥ʤΥơ֥ϳߤǳ
 *  װ˱SRꤹɬפ뤿ᡤɽȤ롥ޤ
 *  ߥϥɥǤΤᡤIPMǤϤʤߥϥ
 *  ¹ԻSRƱ˻ġΤᡤIPMͤΤߤ
 *  ϡ8bitΤߤ򻲾Ȥɬפ롥Ƥϥե졼
 *  Ū롥
 */
extern const uint32_t int_iipm_tbl[TNUM_INT];

/*
 *  ׵ػߥե饰Υå
 *
 *  ͥ쥸(IPRAG)0ꤹ롥
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    uint16_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

    /*
     *  °ꤵƤʤ
     */
    if ((iipm & 0x01U) != 0) {
        return(false);
    }
    
    /* 
     *  ֹбIPRͤ0ˤ롥
     */
    set_irc_ipr(address, offset, 0x00);

    return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ׵ػߥե饰β
 *
 *  ͥ쥸(IPRAG)򸵤᤹ͤ
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    uint16_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

    /*
     *  °ꤵƤʤ
     */
    if ((iipm & 0x01U) != 0) {
        return(false);
    }

    /* 
     *  ֹбIPRͤ򥻥åȤ
     */
    set_irc_ipr(address, offset, (-EXT_IPM(iipm & 0xF0U)));
    
    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *  ׵饤°
 *
 *  SH34Ǥϡͥǰͥ٤16ʳǤ뤿ᡤintpri
 *  ȤͿ뤳ȤǤͤ-15-1ɸǤ롥
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 *
 */
Inline void
i_begin_int(INTNO intno)
{
#ifdef SH3    
    uint8_t irr0_val;

    /*
     *  PINTIRQߤǤġåȥꥬξϳ׵򥯥ꥢ롥
     *  åȥꥬȽǤΤݤʤΤǡ˥ꥢ롥
     */
    if (INTNO_PINT(intno)) {
        irr0_val = sil_reb_mem((void *) IRR0);
        irr0_val &= ~(0x40U << INTNO_PINT_OFFSET(intno));
        sil_wrb_mem((void *) IRR0, irr0_val);
    }
    else if (INTNO_IRQ(intno)) {
        irr0_val = sil_reb_mem((void *) IRR0);
        irr0_val &= ~(0x01U << INTNO_IRQ_OFFSET(intno));
        sil_wrb_mem((void *) IRR0, irr0_val);
    }
#else /* SH4 */
    const uint32_t clear_tbl[8] = {
         0x01000000, /* IRQ7 */
         0x80000000, /* IRQ0 */
         0x40000000, /* IRQ1 */
         0x20000000, /* IRQ2 */
         0x10000000, /* IRQ3 */
         0x08000000, /* IRQ4 */
         0x04000000, /* IRQ5 */
         0x02000000  /* IRQ6 */
       };

    /*
     *  IRQn(n=07)ߤǤġåȥꥬξϳ׵򥯥ꥢ롥
     *  åȥꥬȽǤΤݤʤΤǡ˥ꥢ롥
     */
    if (INTNO_IRQ(intno)) {
        sil_wrw_mem((void *)INTREQ, ~clear_tbl[((intno - TMIN_IRQNO) >> 6)]);
    }
#endif /* SH3 */
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  ̤γߥϥɥ(default_int_handler())ΰ p_excinf
 *  ƼФΥޥ
 */
#define P_EXCINF_INT_OFFSET_SSR     (13U)
#define P_EXCINF_INT_OFFSET_SPC     (15U)
#define P_EXCINF_INT_OFFSET_PR      (14U)

/*
 *  CPU㳰ϥɥط
 */ 

/*
 *  㳰ϥɥ p_excinf ƼФΥޥ
 */
#ifdef FPU_ENABLE

#ifdef FPU_SAVE_BANKED_REG

#define P_EXCINF_EXC_OFFSET_SSR     (12U + 14U + 16U)
#define P_EXCINF_EXC_OFFSET_SPC     (14U + 14U + 16U)
#define P_EXCINF_EXC_OFFSET_PR      (13U + 14U + 16U)
#define P_EXCINF_EXC_OFFSET_EXPEVT    0U 

#else

#define P_EXCINF_EXC_OFFSET_SSR     (12U + 14U)
#define P_EXCINF_EXC_OFFSET_SPC     (14U + 14U)
#define P_EXCINF_EXC_OFFSET_PR      (13U + 14U)
#define P_EXCINF_EXC_OFFSET_EXPEVT    0U

#endif /* FPU_SAVE_BANKED_REG */

#else

#define P_EXCINF_EXC_OFFSET_SSR     12U
#define P_EXCINF_EXC_OFFSET_SPC     14U
#define P_EXCINF_EXC_OFFSET_PR      13U
#define P_EXCINF_EXC_OFFSET_EXPEVT   0U

#endif /* FPU_ENABLE */

/*
 *  CPU㳰ϥɥϿѥơ֥
 */
extern const FP exch_tbl[TNUM_EXC];

/*
 *  CPU㳰ϥɥ
 */
Inline void
x_define_exc(EXCNO excno, FP exc_entry)
{       
}

/*
 *  CPU㳰ϥɥޥ
 */
#define EXC_ENTRY(excno, exchdr)    exchdr
#define EXCHDR_ENTRY(excno, excno_num, exchdr) extern void exchdr(void *p_excinf);

/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤλfalse
 *  Ǥʤtrue֤
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
    uint32_t nest;

    Asm("stc r7_bank,%0" : "=r"(nest));
    return(nest > 1U);
}

/*
 *  CPU㳰ȯIPMʥϡɥγͥ٥ޥɽ
 *  ˤλ
 */
Inline uint16_t
exc_get_iipm(void *p_excinf)
{
    return(*(((uint32_t *) p_excinf) + P_EXCINF_EXC_OFFSET_SSR) & 0x00F0U);
}

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥ֤ǤtrueǤʤ
 *  false֤CPU㳰ͥγ߽ȯ
 *  ˤfalse֤ˡ
 *
 *  SHǤϡCPU㳰ȯIPMʥϡɥγͥ٥ޥ
 *  ٤ƤγߤĤ֤Ǥ뤳Ȥå뤳Ȥǡ
 *  ͥ¹Ǥʤȡߥå֤ǤʤȡCPUå֤Ǥ
 *  ȡʥǥΡ˳ͥ٥ޥ֤Ǥ뤳Ȥ4Ĥ
 *  å뤳ȤǤCPU㳰ȯlock_flag
 *  ȤɬפϤʤˡ
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
                    && exc_get_iipm(p_excinf) == IIPM_ENAALL);
}

/*
 * Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 * ̤Ͽγߤȯ˸ƤӽФ
 */
extern void default_int_handler(void *p_excinf);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
